// ThrottleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Throttle.h"
#include "ThrottleDlg.h"
#include ".\throttledlg.h"
#include "acpi.h"
#include "CpuUsage.h"
#include "trayIcon.h"
#include <conio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define THROTTLE_TO_PERCENT(x) ( (x)*100/16 ) 
#define PERCENT_TO_THROTTLE(x) ( ((int)(x)+1)*16/100 )  // +1 fixes rounding

extern DWORD g_minCPU;
extern DWORD g_maxCPU;
extern DWORD g_fsCPU;
extern DWORD g_minThrottle;
extern DWORD g_maxThrottle;
extern DWORD g_delay;
extern DWORD g_autoenabled;
extern DWORD g_initializing;
extern void LoadSettings();
extern void SaveSettings();

bool g_bIgnoreNextSliderSet = false;

#define SYSTRAY_ICON_SLOT 27 //just pick some number, use it consistently

// CThrottleDlg dialog


CThrottleDlg::CThrottleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CThrottleDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bSuspending = false;
	m_nPreSuspendNonAutoThrottleValue = 0;
	m_bIconShowing = false;
	m_currentThrottle = 0;
}

void CThrottleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SLIDER12_5, m_throttleSlider);
	DDX_Control(pDX, IDC_THROTTLE_PERCENT, m_ThrottlePercentage);
	DDX_Control(pDX, IDC_CPUTHRESHMIN, m_minCPUThresh);
	DDX_Control(pDX, IDC_CPUTHRESHMINSPIN, m_spinMinCpuThresh);
	DDX_Control(pDX, IDC_CPUTHRESHMAX, m_maxCPUThresh);
	DDX_Control(pDX, IDC_CPUTHRESHMAXSPIN, m_spinMaxCpuThresh);
	DDX_Control(pDX, IDC_FULLSPEEDTHRESH, m_fsCPUThresh);
	DDX_Control(pDX, IDC_FULLSPEEDTHRESHSPIN, m_spinFsCpuThresh);
	DDX_Control(pDX, IDC_MIN_THROTTLE, m_minThrottle);
	DDX_Control(pDX, IDC_MIN_THROTTLE_SPIN, m_spinMinThrottle);
	DDX_Control(pDX, IDC_MAX_THROTTLE, m_maxThrottle);
	DDX_Control(pDX, IDC_MAX_THROTTLE_SPIN, m_spinMaxThrottle);
	DDX_Control(pDX, IDC_RESAMPLETIME, m_pollingInterval);
	DDX_Control(pDX, IDC_AUTOTHTENA, m_autoThrottleEna);
	DDX_Control(pDX, IDC_SHOWSET, m_showSet);
	DDX_Control(pDX, IDC_CPUUSAGEVAL, m_CPUUtilizationTextVal);
}

BEGIN_MESSAGE_MAP(CThrottleDlg, CDialog)
	ON_WM_VSCROLL()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER12_5, OnNMCustomdrawSlider)
	ON_NOTIFY(UDN_DELTAPOS, IDC_CPUTHRESHMINSPIN, OnDeltaposCputhreshminspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_CPUTHRESHMAXSPIN, OnDeltaposCputhreshmaxspin)
	
	ON_WM_QUERYDRAGICON()
	ON_REGISTERED_MESSAGE(WM_TI_TASKBARCREATED, OnTaskBarCreated)
	ON_REGISTERED_MESSAGE(WM_TI_NOTIFYICON, OnNotifyIcon)

	ON_WM_SYSCOMMAND() 
	ON_BN_CLICKED(IDC_OK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_AUTOTHTENA, OnBnClickedAutothtena)
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_RESAMPLETIME, OnEnChangeResampletime)
	ON_NOTIFY(UDN_DELTAPOS, IDC_MIN_THROTTLE_SPIN, OnDeltaposMinThrottleSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_MAX_THROTTLE_SPIN, OnDeltaposMaxThrottleSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_FULLSPEEDTHRESHSPIN, OnDeltaposFullspeedthreshspin)
	ON_BN_CLICKED(IDC_SHOWSET, OnBnClickedShowset)
	ON_STN_CLICKED(IDC_MIN, OnStnClickedMin)
END_MESSAGE_MAP()


// CThrottleDlg message handlers
void CThrottleDlg::OnSysCommand(UINT nID, LPARAM lParam)  // trap minimize button press
{
    if (nID == SC_MINIMIZE)
			ShowWindow(SW_HIDE);	// hide the app altogether becuase it's now in the system tray.
	else
        CDialog::OnSysCommand(nID, lParam);
}


// position the slider to where the throttle amount is currently.  
// this version works for both VIA and intel based chipsets.  (VIA uses a 6.25% gradient)
BOOL CThrottleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	RECT r;
	GetWindowRect(&r);
	m_orig_window_w = r.right - r.left;
	m_orig_window_h = r.bottom - r.top;
	GetDlgItem(IDC_AUTO_GROUP)->GetWindowRect(&r);
	m_orig_autogroup_w = r.right - r.left;
	m_orig_autogroup_h = r.bottom - r.top;

	if (minimizeAfterNSeconds <= 0)
		GetDlgItem(IDC_MIN)->ShowWindow(false);


	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon



		m_aHandler = new MouseMsgHandlerPtr[1];
		MouseMsgHandlerPtr mouse_handler = new MyMouseMsgHandler();
		m_aHandler[0] = mouse_handler;
		m_pTrayIcon = new CTrayIcon(m_hWnd, SYSTRAY_ICON_SLOT, m_hIcon, _T("winThrottle"), m_aHandler, 1);
		m_pTrayIcon->AddIcon();

	




	int pos;
	CString txt;

	m_throttleSlider.SetRange(0, 100);
	for (int i=0; i<=15; i += (isVia ? 1 : 2))
		m_throttleSlider.SetTic(THROTTLE_TO_PERCENT(i));
	pos=ThrottleValue & (~THROTTLE_ENABLE_BIT);			// mask off enable bit (BIT4) Value is now 0-7 or 0-15
	pos=(16-pos);										// hardware value is inverted from slider value
	setSliderValue(pos);								
	
	m_spinMinCpuThresh.SetRange32(0, 99);
	m_spinMaxCpuThresh.SetRange32(0, 99);
	m_spinFsCpuThresh.SetRange32(0, 99);
	m_spinMinCpuThresh.SetPos(minCPU);
	m_spinMaxCpuThresh.SetPos(maxCPU);
	m_spinFsCpuThresh.SetPos(fsCPU);
	txt.Format("%3d",minCPU);
	m_minCPUThresh.SetWindowText(txt);
	txt.Format("%3d",maxCPU);
	m_maxCPUThresh.SetWindowText(txt);
	txt.Format("%3d",fsCPU);
	m_fsCPUThresh.SetWindowText(txt);

	m_spinMinThrottle.SetRange32(0, 99);
	m_spinMaxThrottle.SetRange32(0, 99);
	m_spinMinThrottle.SetPos(minThrottle);
	m_spinMaxThrottle.SetPos(maxThrottle);
	txt.Format("%3d",minThrottle);
	m_minThrottle.SetWindowText(txt);
	txt.Format("%3d",maxThrottle);
	m_maxThrottle.SetWindowText(txt);

	txt.Format("%3d",delay);
	m_pollingInterval.SetWindowText(txt);
	int SystemWideCpuUsage = usageA.GetCpuUsage();		// call the usage timer 1 time to initialize it.
	if (autoEnabled)
		m_autoThrottleEna.SetCheck(1);

	g_timeOut=0;
	OnBnClickedAutothtena();

	m_UpdateTimer = SetTimer(1, (1000), NULL);  // set a 1 second timer.  

	g_initializing = false;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// set position on slider.   
// input is 0-15, need to convert into 1-100 for slider position.
void CThrottleDlg::setSliderValue(int pos) 
{
	pos &= 0xF;		// mask down to 0-15, just in case.
	int percent = THROTTLE_TO_PERCENT(pos);
	 
	g_bIgnoreNextSliderSet = true;	// otherwise .SetPos will trigger a bunch of other code!
	m_throttleSlider.SetPos(percent);
}


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CThrottleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);

	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
//HCURSOR CThrottleDlg::OnQueryDragIcon()
//{
//	return static_cast<HCURSOR>(m_hIcon);
//}

// slider -> chipset value converter
void CThrottleDlg::OnNMCustomdrawSlider(NMHDR *pNMHDR, LRESULT *pResult)
{
	if (g_bIgnoreNextSliderSet) {
		g_bIgnoreNextSliderSet = false;
		return;
	}

	LPNMCUSTOMDRAW pNMCD = reinterpret_cast<LPNMCUSTOMDRAW>(pNMHDR);  //wtf is this?
	int pos, val=0;

	pos = m_throttleSlider.GetPos();

	// slider range goes from 1-100.
	// we need a range from 0 to 7 (or 0-15 if via)
	val = (BYTE)((pos-1) / 6.25);  // 6.25% increments for via
	
	if (!isVia)
		val &= 0xfe;  // force to multiples of 2 if non via

	setNewThrottleValue(val);
	*pResult = 0;
}

// set a new value in the throttle register based on input (0-15)
void CThrottleDlg::setNewThrottleValue(int val)
{
	// note: saves 'val' to 'm_currentThrottle'!

	BYTE ThrottleValue;
	int nThrottlePercent = THROTTLE_TO_PERCENT(val);

	// get a pointer to our app object so we can access common functions
	CThrottleApp* pApp = (CThrottleApp*)AfxGetApp();

	// clip throttlePercent vs. latest min/max 
	// throttle values from edit ctrls:
	if (m_autoThrottleEna.GetCheck()) {
		if (nThrottlePercent > maxThrottle)
			nThrottlePercent = maxThrottle;
		//if (nThrottlePercent < minThrottle)
		//	nThrottlePercent = minThrottle;
		//...disabled just in case registry values somehow got corrupted
		//  (since currently this option is hidden!)
	}

	m_currentThrottle = min(15,max(0,PERCENT_TO_THROTTLE(nThrottlePercent)));
	m_currentThrottleInHW = (isVia ? m_currentThrottle : ((m_currentThrottle/2)*2));

	// convert value to a string:
	CString throttlePercent;
	if (m_currentThrottle==0)
		throttlePercent="Off";
	else { 
		char buf[256];
		sprintf(buf, "%d%%", THROTTLE_TO_PERCENT(m_currentThrottleInHW));
		throttlePercent = buf;
	}

	m_ThrottlePercentage.SetWindowText(throttlePercent);	// update the dialog text
	if (throttlePercent != "Off") throttlePercent +=" throttled";

	int nLen = throttlePercent.GetLength();					// update the system tray text
	LPTSTR lpszBuf = throttlePercent.GetBuffer(nLen);

	// update the tray icon text with new throttle info
	DWORD icon = IDI_ICON1;
	switch(m_currentThrottle) {
		case 0: icon  = IDI_LEVEL0; break;
		case 1: icon  = IDI_LEVEL1; break;
		case 2: icon  = IDI_LEVEL2; break;
		case 3: icon  = IDI_LEVEL3; break;
		case 4: icon  = IDI_LEVEL4; break;
		case 5: icon  = IDI_LEVEL5; break;
		case 6: icon  = IDI_LEVEL6; break;
		case 7: icon  = IDI_LEVEL7; break;
		case 8: icon  = IDI_LEVEL8; break;
		case 9: icon  = IDI_LEVEL9; break;
		case 10: icon = IDI_LEVEL10; break;
		case 11: icon = IDI_LEVEL11; break;
		case 12: icon = IDI_LEVEL12; break;
		case 13: icon = IDI_LEVEL13; break;
		case 14: icon = IDI_LEVEL14; break;
		case 15: icon = IDI_LEVEL15; break;
	}
	
	
	//m_pTrayIcon->setToolTip(lpszBuf);  // updates the tooltip text (only) on the systray icon
	 // better: update the text AND the icon!
	 HICON newIcon = AfxGetApp()->LoadIcon(icon);
	 m_pTrayIcon->SetTrayIcon(m_hWnd, SYSTRAY_ICON_SLOT, newIcon, lpszBuf);	
	m_pTrayIcon->upDateIcon();

	val = m_currentThrottle;
	if (!isVia)                                             // hide # of steps from user
		val = (val/2)*2;
	ThrottleValue=(16 - val) | THROTTLE_ENABLE_BIT;			// set new value in hardware
	if (ThrottleValue==16) ThrottleValue=0;  
		pApp->ioPortWriteByte(AcpiBaseAddress+THROTTLE_REGISTER, ThrottleValue); //_outp(AcpiBaseAddress+THROTTLE_REGISTER, ThrottleValue);// write the new throttle value
}


void DoSpin(int& val, DWORD& gVal, CEdit& edit, int delta)
{
	CString txt;

	// inc/dec the value, and update the edit control text:
	edit.GetWindowText(txt);
	sscanf(txt,"%d",&val);
	val = max(0, min(100, val + delta));
	txt.Format("%3d", val);
	edit.SetWindowText(txt);

	// save setting to registry:
	if (!g_initializing) {
		gVal = val;
		SaveSettings();
	}
}

void CThrottleDlg::OnDeltaposMinThrottleSpin(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	*pResult = 0;
	DoSpin(minThrottle, g_minThrottle, m_minThrottle, pNMUpDown->iDelta);
}

void CThrottleDlg::OnDeltaposMaxThrottleSpin(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	*pResult = 0;

	CString txt;
	m_maxThrottle.GetWindowText(txt);
	int val;
	sscanf(txt,"%d",&val);
	val = max(0, min(100, val));
	int cur_throttle = PERCENT_TO_THROTTLE(val);
	if (!isVia)
		cur_throttle = (cur_throttle/2) * 2;
	int new_throttle = cur_throttle + pNMUpDown->iDelta * (isVia ? 1 : 2);
	new_throttle = max(0, min( 15, new_throttle ));
	if (!isVia)
		new_throttle = (new_throttle/2) * 2;
	int new_val = THROTTLE_TO_PERCENT(new_throttle);
	int snapped_delta = new_val - val;

	DoSpin(maxThrottle, g_maxThrottle, m_maxThrottle, snapped_delta);
}

void CThrottleDlg::OnDeltaposCputhreshminspin(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	*pResult = 0;
	DoSpin(minCPU, g_minCPU, m_minCPUThresh, pNMUpDown->iDelta);
}

void CThrottleDlg::OnDeltaposCputhreshmaxspin(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	*pResult = 0;
	DoSpin(maxCPU, g_maxCPU, m_maxCPUThresh, pNMUpDown->iDelta);
}

void CThrottleDlg::OnDeltaposFullspeedthreshspin(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	*pResult = 0;
	DoSpin(fsCPU, g_fsCPU, m_fsCPUThresh, pNMUpDown->iDelta);
}


	


void CThrottleDlg::OnBnClickedOk()  // apply and exit
{
	KillTimer(m_UpdateTimer);
	delete m_pTrayIcon;
	OnOK();
}
void CThrottleDlg::OnCancel() 
{
	// stop the timer
	KillTimer(m_UpdateTimer);
	delete m_pTrayIcon;
	CDialog::OnCancel();
}

void CThrottleDlg::OnBnClickedAutothtena()
{
	// turn off 3 second warning
	if (!g_initializing)
		OnStnClickedMin();

	//gray or ungray auto throttle stuff
	grayAutoThrottle(m_autoThrottleEna.GetCheck(), m_showSet.GetCheck());
	
	/*
	if (m_autoThrottleEna.GetCheck())
	{
		m_UpdateTimer = SetTimer(1, (1000), NULL);  // set a 1 second timer.  

		// update the cpu usage the instant the button is clicked
		int SystemWideCpuUsage = usageA.GetCpuUsage();
		CString txt;
		txt.Format("%3d%%",SystemWideCpuUsage);
		m_CPUUtilizationTextVal.SetWindowText( txt.GetString() );
	}
	else
		KillTimer(m_UpdateTimer);
	*/

	if (!g_initializing) {
		g_autoenabled = m_autoThrottleEna.GetCheck();
		SaveSettings();
	}
}
void CThrottleDlg::grayAutoThrottle(BOOL ena, BOOL bShowSettings)
{
	m_pollingInterval.EnableWindow(ena);
	m_minCPUThresh.EnableWindow(ena);
	m_spinMinCpuThresh.EnableWindow(ena);
	m_maxCPUThresh.EnableWindow(ena);
	m_spinMaxCpuThresh.EnableWindow(ena);
	m_fsCPUThresh.EnableWindow(ena);
	m_spinFsCpuThresh.EnableWindow(ena);
	//m_minThrottle.EnableWindow(ena);
	//m_spinMinThrottle.EnableWindow(ena);
	m_maxThrottle.EnableWindow(ena);
	m_spinMaxThrottle.EnableWindow(ena);
	GetDlgItem(IDC_STATIC_TH0)->EnableWindow(ena);
	GetDlgItem(IDC_STATIC_TH1)->EnableWindow(ena);
	GetDlgItem(IDC_STATIC_TH2)->EnableWindow(ena);
	GetDlgItem(IDC_STATIC_TH3)->EnableWindow(ena);
	GetDlgItem(IDC_STATIC_TH4)->EnableWindow(ena);
	GetDlgItem(IDC_STATIC_TH5)->EnableWindow(ena);
	GetDlgItem(IDC_STATIC_TH6)->EnableWindow(ena);
	GetDlgItem(IDC_STATIC_TH7)->EnableWindow(ena);
	GetDlgItem(IDC_STATIC_TH8)->EnableWindow(ena);
	GetDlgItem(IDC_STATIC_TH9)->EnableWindow(ena);

	m_pollingInterval.ShowWindow(bShowSettings);
	m_minCPUThresh.ShowWindow(bShowSettings);
	m_spinMinCpuThresh.ShowWindow(bShowSettings);
	m_maxCPUThresh.ShowWindow(bShowSettings);
	m_spinMaxCpuThresh.ShowWindow(bShowSettings);
	m_fsCPUThresh.ShowWindow(bShowSettings);
	m_spinFsCpuThresh.ShowWindow(bShowSettings);
	//m_minThrottle.ShowWindow(bShowSettings);
	//m_spinMinThrottle.ShowWindow(bShowSettings);
	m_maxThrottle.ShowWindow(bShowSettings);
	m_spinMaxThrottle.ShowWindow(bShowSettings);
	GetDlgItem(IDC_STATIC_TH0)->ShowWindow(bShowSettings);
	GetDlgItem(IDC_STATIC_TH1)->ShowWindow(bShowSettings);
	GetDlgItem(IDC_STATIC_TH2)->ShowWindow(bShowSettings);
	GetDlgItem(IDC_STATIC_TH3)->ShowWindow(bShowSettings);
	GetDlgItem(IDC_STATIC_TH4)->ShowWindow(bShowSettings);
	GetDlgItem(IDC_STATIC_TH5)->ShowWindow(bShowSettings);
	GetDlgItem(IDC_STATIC_TH6)->ShowWindow(bShowSettings);
	GetDlgItem(IDC_STATIC_TH7)->ShowWindow(bShowSettings);
	GetDlgItem(IDC_STATIC_TH8)->ShowWindow(bShowSettings);
	GetDlgItem(IDC_STATIC_TH9)->ShowWindow(bShowSettings);

	// also size the dialog
	int dh = bShowSettings ? 0 : -102;
	SetWindowPos(NULL,0,0, m_orig_window_w, m_orig_window_h + dh, SWP_NOMOVE|SWP_NOZORDER);
	GetDlgItem(IDC_AUTO_GROUP)->SetWindowPos(NULL,0,0, m_orig_autogroup_w, m_orig_autogroup_h + dh, SWP_NOMOVE|SWP_NOZORDER);
}

void CThrottleDlg::OnTimer(UINT nIDEvent)
{
	CString txt;
	DWORD min, max, fs;
	bool newSetting=false;

	if (m_bSuspending)
		return;

	// the systray icon won't show up until the first time 
	// the throttle actually *changes*, which can feel
	// like a bug... so we always show it right away:
	if (!m_bIconShowing) {
		m_bIconShowing = true;
		m_pTrayIcon->upDateIcon();
	}

	// update cpu utilization indicator
	int SystemWideCpuUsage = usageA.GetCpuUsage();
	char buf[256];
	sprintf(buf, "%3d%%", SystemWideCpuUsage);
	m_CPUUtilizationTextVal.SetWindowText( buf );

	// if auto-throttle was on @ startup, minimize it after 3 seconds
	if (minimizeAfterNSeconds > 0) {
		minimizeAfterNSeconds--;
		char buf[256];
		sprintf(buf, "Minimizing to tray icon in %d seconds...", minimizeAfterNSeconds);
		GetDlgItem(IDC_MIN)->SetWindowText(buf);
		if (minimizeAfterNSeconds==0) {
			ShowWindow(SW_HIDE);
			GetDlgItem(IDC_MIN)->ShowWindow(false);
		}
	}

	if (m_autoThrottleEna.GetCheck())
	{
		// read latest cpu usage thresholds, 
		// then we'll see if we're above or below the limits
		m_maxCPUThresh.GetWindowText(txt);
		sscanf(txt,"%d",&max);
	 	m_minCPUThresh.GetWindowText(txt);
		sscanf(txt,"%d",&min);
	 	m_fsCPUThresh.GetWindowText(txt);
		sscanf(txt,"%d",&fs);
		
		// read latest min/max throttle values from edit ctrls
		int oldMinThrottle=minThrottle, oldMaxThrottle=maxThrottle;
		m_minThrottle.GetWindowText(txt);
		sscanf(txt,"%d",&minThrottle);
		m_maxThrottle.GetWindowText(txt);
		sscanf(txt,"%d",&maxThrottle);
		
		// update the spin controls so they're in sync with the edit boxes:
		m_spinMinCpuThresh.SetPos(min);
		m_spinMaxCpuThresh.SetPos(max);
		m_spinFsCpuThresh.SetPos(fs);
		m_spinMinThrottle.SetPos(minThrottle);
		m_spinMaxThrottle.SetPos(maxThrottle);

		// save to registry: [..only really saves if they've changed]
		if (!g_initializing) {
			g_minCPU = min;
			g_maxCPU = max;
			g_fsCPU  = fs;
			g_minThrottle = minThrottle;
			g_maxThrottle = maxThrottle;
			SaveSettings();
		}

		// countdown our timer before attempting to auto-throttle back down.		
		if (g_timeOut > 0) g_timeOut--;

		if (SystemWideCpuUsage > (int)fs) 
		{ 
			// to make the computer a bit more responsive, throttle up quickly when CPU usage is high.
			m_currentThrottle = 0;	// force it to full speed.
			g_timeOut = delay;		// use user input to know how many seconds to wait.
			newSetting=true;
		}
		else if (SystemWideCpuUsage > (int)max) 
		{
			// throttle down a bit if utilization is highish
			if (m_currentThrottle >= 1)//(isVia ? 1 : 2))
			{
				m_currentThrottle -= 1;//(isVia ? 1 : 2);
				newSetting = true;
			}
		}
		else if ( (SystemWideCpuUsage < (int)min) && (g_timeOut == 0))
		{ 
			// attempt to slow down the CPU
			if (m_currentThrottle < 15)//(isVia ? 15 : 14))
			{
				m_currentThrottle += 1;//(isVia ? 1 : 2);
				newSetting = true;
			}
		}

		/*if (m_bSuspending && m_currentThrottle != 0)
		{
			m_currentThrottle = 0;	// force it to full speed.
			newSetting = true;
		}*/

		if (oldMinThrottle != minThrottle || 
			oldMaxThrottle != maxThrottle ) 
		{
			newSetting = true;	// just force it to update (..re-applies max throttle limit)
		}

		if (newSetting)  // only refresh display when throttle actually changes.
		{
			setNewThrottleValue(m_currentThrottle);	// actual value to write to hardware is inverse of slider position
			setSliderValue( m_currentThrottleInHW );
		}
	}
}

// user has typed in the seconds field.  Update the timer again.
void CThrottleDlg::OnEnChangeResampletime()
{
	CString txt;
	DWORD seconds;
	m_pollingInterval.GetWindowText(txt);
	sscanf(txt,"%d",&seconds);
	if (seconds > 255) seconds = 255;
	delay=(BYTE)seconds;				// update timeout counter

	// save setting to registry:
	if (!g_initializing) {
		g_delay = delay;
		SaveSettings();
	}
}
HCURSOR CThrottleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

LRESULT CThrottleDlg::OnTaskBarCreated(WPARAM wParam, LPARAM lParam)
{
    return (m_pTrayIcon->OnTaskBarCreated(wParam, lParam) );
}

LRESULT CThrottleDlg::OnNotifyIcon(WPARAM wParam, LPARAM lParam) 
{ 
	m_pTrayIcon->OnNotifyIcon(wParam, lParam);
	return (0);
}

void MyMouseMsgHandler::MouseMsgHandler(UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg) {
	case WM_LBUTTONDOWN:
	case WM_LBUTTONDBLCLK:
	case WM_RBUTTONDOWN:
		AfxGetMainWnd()->ShowWindow(SW_SHOW);	
		// also bring to top of Z order:
		::SetForegroundWindow(AfxGetMainWnd()->m_hWnd);
		::SetActiveWindow(AfxGetMainWnd()->m_hWnd);
		break;
	}
}

LRESULT CThrottleDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	// TODO: Add your specialized code here and/or call the base class
	if (message == WM_POWERBROADCAST) {
		switch(wParam) {
			case PBT_APMSUSPEND:
				::OutputDebugString("WinThrottle: entering suspend mode.\n");
				if (m_autoThrottleEna.GetCheck()) {
					KillTimer(m_UpdateTimer);
				}
				else {
					m_nPreSuspendNonAutoThrottleValue = m_currentThrottle;
				}
				setNewThrottleValue(0);	// actual value to write to hardware is inverse of slider position
				setSliderValue(m_currentThrottle);
				m_bSuspending = true;
				break;
			case PBT_APMRESUMESUSPEND:
			case PBT_APMRESUMECRITICAL:
			case PBT_APMRESUMEAUTOMATIC:
				::OutputDebugString("WinThrottle: returned from suspend mode.\n");
				m_bSuspending = false;
				if (m_autoThrottleEna.GetCheck()) {
					g_timeOut = 3;
					m_UpdateTimer = SetTimer(1, (1000), NULL);  // set a 1 second timer.  
				}
				else {
					setNewThrottleValue(m_nPreSuspendNonAutoThrottleValue);	// actual value to write to hardware is inverse of slider position
					setSliderValue(m_currentThrottle);
				}
				break;
		}
	}

	return CDialog::WindowProc(message, wParam, lParam);
}



void CThrottleDlg::OnBnClickedShowset()
{
	// turn off 3 second warning
	if (!g_initializing)
		OnStnClickedMin();

	grayAutoThrottle(m_autoThrottleEna.GetCheck(), m_showSet.GetCheck());
}


void CThrottleDlg::OnStnClickedMin()
{
	GetDlgItem(IDC_MIN)->ShowWindow(false);
	minimizeAfterNSeconds = -1;
}
