// ThrottleDlg.h : header file
//

#pragma once
#include "afxcmn.h"
#include "afxwin.h"
#include "cpuUsage.h"
#include "trayIcon.h"


// CThrottleDlg dialog
class CThrottleDlg : public CDialog
{
// Construction
public:
	CThrottleDlg(CWnd* pParent = NULL);	// standard constructor
	
// Dialog Data
	enum { IDD = IDD_THROTTLE_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;
	CTrayIcon* m_pTrayIcon;
	UINT_PTR m_UpdateTimer;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg LRESULT OnTaskBarCreated(WPARAM wp, LPARAM lp);
	afx_msg LRESULT OnNotifyIcon(WPARAM wp, LPARAM lp);
	afx_msg void OnHide();
	afx_msg void OnShow();
	DECLARE_MESSAGE_MAP()
public:
	MouseMsgHandlerPtr *m_aHandler;
	BYTE ThrottleValue;
	BOOL isVia;
	WORD AcpiBaseAddress;
	int  minCPU;
	int  maxCPU;
	int  fsCPU;
	int  delay;
	int  minThrottle;
	int  maxThrottle;
	BOOL autoEnabled;
	int  minimizeAfterNSeconds;
	int	 g_timeOut;
	int m_currentThrottle;  // 0-15 current value
	int m_currentThrottleInHW;  // 0-15 for via; 0/2/4/6/8/10/12/14 for non-via
	bool m_bIconShowing;
	CCpuUsage usageA;
	afx_msg void OnTimer(UINT nIDEvent);
	CSliderCtrl m_throttleSlider;
	afx_msg void OnNMCustomdrawSlider(NMHDR *pNMHDR, LRESULT *pResult);
	void grayAutoThrottle(BOOL ena, BOOL bShowSettings);
	void setSliderValue(int pos);
	CEdit m_ThrottlePercentage;
	CEdit m_pollingInterval;
	CEdit m_minCPUThresh;
	CEdit m_maxCPUThresh;
	CEdit m_fsCPUThresh;
	CSpinButtonCtrl m_spinMinCpuThresh;
	CSpinButtonCtrl m_spinMaxCpuThresh;
	CSpinButtonCtrl m_spinFsCpuThresh;
	CEdit m_minThrottle;
	CEdit m_maxThrottle;
	CSpinButtonCtrl m_spinMinThrottle;
	CSpinButtonCtrl m_spinMaxThrottle;
	CButton m_autoThrottleEna;
	CButton m_showSet;
	afx_msg void OnDeltaposCputhreshminspin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposCputhreshmaxspin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedOk();
	void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnBnClickedAutothtena();
	void setNewThrottleValue(int val);
	CStatic m_CPUUtilizationTextVal;
	afx_msg void OnEnChangeResampletime();
	protected:
	virtual void OnCancel();

	int m_orig_window_w;
	int m_orig_window_h;
	int m_orig_autogroup_w;
	int m_orig_autogroup_h;

public:
protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

	bool m_bSuspending;  // really means suspended OR about to suspend
	int  m_nPreSuspendNonAutoThrottleValue;
public:
	afx_msg void OnEnChangeMinThrottle();
	afx_msg void OnEnChangeMaxThrottle();
	afx_msg void OnDeltaposMinThrottleSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposMaxThrottleSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposFullspeedthreshspin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedShowset();
	afx_msg void OnStnClickedCurrentcputxt();
	afx_msg void OnStnClickedMin();
};

class MyMouseMsgHandler : public CTrayIconMouseMsgHandler
{
public:
	MyMouseMsgHandler() {}
	virtual void MouseMsgHandler(UINT msg, WPARAM wParam, LPARAM lParam);
};
