#if !defined(TRAYICON_H)
#define TRAYICON_H

#include <string.h>

const UINT WM_TI_TASKBARCREATED = ::RegisterWindowMessage(_T("TaskbarCreated"));

const UINT WM_TI_NOTIFYICON = ::RegisterWindowMessage(_T("NotifyIcon"));

class CTrayIconMouseMsgHandler;

typedef CTrayIconMouseMsgHandler* MouseMsgHandlerPtr;

class CTrayIcon:public CObject
{
public:

	CTrayIcon(HWND hWnd, UINT uIconID, HICON hIcon, LPSTR lpToolTip, MouseMsgHandlerPtr *pMouseMsgHandler, int nHandlers);


	~CTrayIcon();

	void SetTrayIcon(HWND hWnd, UINT uIconID, HICON hIcon, LPSTR lpToolTip);
	void CTrayIcon::setToolTip(LPSTR lpToolTip);

	void SetMouseMsgHandler(MouseMsgHandlerPtr *pMouseMsgHandler, int nHandlers);

	BOOL AddIcon();
	BOOL upDateIcon();

	BOOL DeleteIcon();

	LRESULT OnTaskBarCreated(WPARAM wParam, LPARAM lParam);

	void OnNotifyIcon(WPARAM wParam, LPARAM lParam);	

private:
	
	CTrayIcon();

	HWND m_hWnd;

	UINT m_uIconID;

	HICON m_hIcon;

	char m_szToolTipText[256];

	MouseMsgHandlerPtr *m_pMouseMsgHandler;

	int m_nHandlers;
};

class CTrayIconMouseMsgHandler: public CObject
{
public:
	CTrayIconMouseMsgHandler() { };
	virtual void MouseMsgHandler(UINT msg, WPARAM wParam, LPARAM lParam) = 0;
};

#endif // TRAYICON_H